
-- Initialize vars
math.randomseed( math.random(os.time()) )
yellow = pge.gfx.createcolor(255, 255, 0)

verdana12 = pge.font.load("data/verdana.ttf", 12, PGE_RAM) ; light36 = pge.font.load("data/light.ttf", 36, PGE_RAM)
verdana24 = pge.font.load("data/verdana.ttf", 24, PGE_RAM)

cardback = pge.texture.load("data/back.png", PGE_RAM) ; pgelogo = pge.texture.load("data/pge.png", PGE_RAM)
felt = pge.texture.load("data/felt.png", PGE_RAM) ; thecards = pge.texture.load("data/thecards.png", PGE_RAM)
hand_ptr = pge.texture.load("data/hand.png", PGE_RAM) ; wild_pk = pge.texture.load("data/wildpick.png", PGE_RAM)
point = pge.texture.load("data/point.png", PGE_RAM)
clk = pge.texture.load("data/clk.png", PGE_RAM); cclk = pge.texture.load("data/cclk.png", PGE_RAM)

intro = pge.wav.load("data/intro.wav") ; card_play = pge.wav.load("data/cardplay.wav")
shuf1 = pge.wav.load("data/shuffle1.wav") no = pge.wav.load("data/no.wav"); rev = pge.wav.load("data/voices/rev.wav")
lastcard = pge.wav.load("data/voices/lastcard.wav")

last = { }; last_called = { }
sk = {}; d2 = {}; d4 = {}
for a = 1,4 do
 sk[a] = pge.wav.load("data/voices/skip"..a..".wav")
 d2[a] = pge.wav.load("data/voices/draw2-"..a..".wav")
 d4[a] = pge.wav.load("data/voices/draw4-"..a..".wav")
	last[a] = 0; last_called[a] = 0
end

woosh = pge.wav.load("data/whooosh.wav")
qj = pge.texture.load("data/qj splash.png", PGE_RAM)
qj2 = pge.texture.load("data/qj2.png", PGE_RAM)
qj3 = pge.texture.load("data/qj3.png", PGE_RAM)

won = 0;  delaer = 0; cur_player = 1; round = 1; newrd = 0
wild = 0; wild_suit = 0; clockwise = 1; last_draw = 0;  ctrl = 0
cards = { } ; player_cards = { } ; playable = { } ; player = { } ;  clr_ct = { } ;  clr_pt = { }
players = 4; game_type = 2; win_sc = 500; draw_type = 2; wild_type = 2 -- set defaults here
aic = 0

-- Intro
function intro1()
 intro:play() ; width = 0; height = 0; sz = 0; lp = 0 ; ang = 0
 for lp = 1,92 do
  sz = sz + .01; 	ang = ang + .07
	 pge.gfx.startdrawing() ;  pge.gfx.clearscreen()
	 cardback:activate() ; width = cardback:width() * sz ; 	height = cardback:height() * sz
	 cardback:draw(135 - (width/2), 146 - (height/2), width, height, 0, 0, cardback:width(), cardback:height(), ang)
  light36:activate();	light36:print(0, 0, yellow, string.sub("Mathfacts Presents:",1,lp/4.65))
  pge.gfx.enddrawing(); pge.gfx.swapbuffers()
	end
 pge.delay(1000000)
 for lp = 1, 49 do
	 pge.gfx.startdrawing() ;  pge.gfx.clearscreen()
	 cardback:activate() ; cardback:draw(135 - (width/2), 146 - (height/2), width, height, 0, 0, cardback:width(), cardback:height(), ang)
  light36:activate();	light36:print(0, 0, yellow, "Mathfacts Presents:")
  light36:print(260, 70, yellow, string.sub("Powered by",1,lp/4.65))
  pge.gfx.enddrawing(); pge.gfx.swapbuffers()
	end
end

function intro2()
lp = 50; d = 1
 while not pge.controls.pressed(PGE_CTRL_START) do
 	pge.controls.update()
  lp = lp + d
  if lp < 50 then d = d * -1; end
		if lp > 254 then d = d * -1; end
	 pge.gfx.startdrawing() ;  pge.gfx.clearscreen()
	 cardback:activate() ; cardback:draw(135 - (width/2), 146 - (height/2), width, height, 0, 0, cardback:width(), cardback:height(), ang)
	 pgelogo:activate() ; pgelogo:draweasy(275,120,0,lp)
  light36:activate();	light36:print(0, 0, yellow, "Mathfacts Presents:") ; light36:print(260, 70, yellow, "Powered by")
  if d == 1 then light36:print(263, 212, yellow, "Press START"); end
  pge.gfx.enddrawing(); pge.gfx.swapbuffers()
	end
end

function contest()
	woosh:play()
	for a = 1, 255 do
   pge.gfx.startdrawing() ;  pge.gfx.clearscreen()
   qj:activate()
	  width = qj:width() * a *.0037 ; 	height = qj:height() * a  *.0042
  	qj:draw((480 - width)/2, (272 - height)/2, width, height, 0, 0, qj:width(), qj:height(), 0,a)
   pge.gfx.enddrawing(); pge.gfx.swapbuffers()
 end

	for a = 1, 255 do
   pge.gfx.startdrawing() ;  pge.gfx.clearscreen()
   qj:activate()
  	qj:draw((480 - width)/2, (272 - height)/2, width, height, 0, 0, qj:width(), qj:height(), 0,255)
   qj2:activate()
  	qj2:draw((480 - width)/2, (272 - height)/2, width, height, 0, 0, qj:width(), qj:height(), 0, a*2.5)
   qj3:activate()
  	qj3:draw((480 - width)/2, (272 - height)/2, width, height, 0, 0, qj:width(), qj:height(), 0, 255- a*2.5 )
   pge.gfx.enddrawing(); pge.gfx.swapbuffers()
	end

qj = nil; qj2 = nil; qj3 = nil; woosh = nil
end

function init_tables()
 for a = 1, 4 do
  player[a] = {count=0, player_cards={0}, playable={0}, selected=4, valid=0, clr_ct={0}, clr_pt={0}, score=0}
 end
end

function clear_cards()
 cards_left = 108
 for a = 1,108 do
  cards[a] = {hand = 0, picx = 0, picy = 0, suit = 0, value = 0}
 end
 for a = 1,108 do
  rc = 0 ; y = 0 ; x = 0
  if a == 1 then rc = 1 ; x = 0; y = 0; end
		if a == 25 then rc = 1; x = 12; y = 0; end
		if a == 26 then rc = 1; x = 0; y = 1; end
		if a == 50 then rc = 1; x = 12; y = 1; end
		if a == 51 then rc = 1; x = 0; y = 2; end
		if a == 75 then rc = 1; x = 12; y = 2; end
		if a == 76 then rc = 1; x = 0; y = 3; end
		if a == 100 then rc = 1; x = 12; y = 3; end
		if a > 100 then rc = 1 ; y = 4; if a > 104 then x = 1 else x = 0; end ; end
		if rc == 0 then
		  y = pge.math.floor(a/25)
    a2 = a - (25 * y) ;  a2 = a2 /2
		  x = pge.math.floor(a2)
		end
  cards[a].hand = 0
	 cards[a].picx = x
	 cards[a].picy = y
	 cards[a].suit = y+1
	 cards[a].value = x
	 if a > 100 then cards[a].value = 98; end
	 if a > 104 then cards[a].value = 99; end
 end
end

function new_round()
			quick()
   verdana24:activate()
   verdana24:print(105,73, yellow, "Player "..newrd.." wins this round")
   verdana12:activate()
	 	verdana12:print(195, 165 , yellow, "Press any key")
  	end_draw()
			cont()
   draw_score()
   total_pts = 0
			draw_background()
   verdana24:activate()
   verdana24:print(10,10, yellow, "Player "..newrd.." won the round.")
			for a = 1,players do
			   examine(a); sum = 0
      for b = 1,5 do
	 	      sum = sum + player[a].clr_pt[b]
   		 end
      if game_type == 1 then 	player[a].score = player[a].score + sum ; end
      verdana24:print(10, 20 + a * 35 , yellow, "Player "..a.."'s cards: " .. sum)
      total_pts = total_pts + sum
			end
			if game_type == 2 then player[newrd].score = player[newrd].score + total_pts; end
			for a = 1,players do
      verdana24:print(270, 20 + a * 35 , yellow,"Total: " .. player[a].score)
			end
   verdana24:print(10, 210, yellow, "Total points this round: "..total_pts)
   end_draw()
			cont()
			check_win()
			if won == 0 then
   			dealer = dealer + 1
			   if dealer > players then dealer = 1 ; end
   			wild = 0 ; wild_suit = 0 ; clockwise = 1 ; last_draw = 0; round = round + 1
      for a = 1, 4 do
         player[a].count=0;  player[a].selected=4 ; player[a].valid=0
			   end
   			for a = 1, 108 do
			      cards[a].hand = 0
   			end
			   cards_left = 108
   			load_hand()
			   starting_card()
   			newrd = 0
			end
end

function draw_score()
			for a = 1,players do
			   examine(a); sum = 0
						if a ~= newrd then
   			   for b = 1,player[a].count do
			         draw_background()
			         cdx = player[a].player_cards[b]
            cdxv = cards[cdx]. value
   			      if cards[cdx]. value > 9 then cdxv = 20; end
			         if cards[cdx]. value > 90 then cdxv = 50; end
			         sum = sum + cdxv
   	 	      x = cards[cdx].picx ;   y = cards[cdx].picy
      	 	   thecards:activate()
            thecards:draw(200, 65 , 78, 124, (x*39) , y * 62, 39, 62, 0, 255)
            verdana24:activate()
            verdana24:print(225, 200 , yellow, cdxv)
            verdana24:print(120, 10 , yellow, "Player "..a.."'s cards: " .. sum)
            if b == player[a].count then
   												verdana24:print(150, 245 , yellow, "Press any key")
   									end
            end_draw()
        	   pge.delay(500000)
         end
						   cont()
						end
			end
end

function pick_card(for_player)
  math.randomseed( math.random(os.time()))
		a = math.random(108)
  while cards[a].hand ~= 0 do
  		a = math.random(108)
  end
		last_draw = a
		cards[a].hand = for_player
  player[for_player].count = player[for_player].count + 1
  player[for_player].player_cards[player[for_player].count] = a
  table.sort(player[for_player].player_cards)

  if for_player == 1 then
 				for c = 1,  player[1].count do
	   	  if player[1].player_cards[c] == a then player[1].selected = c; end
		   end
		end

		last[for_player] = 0; last_called[for_player] = 0
		cards_left = cards_left - 1
  shuffle_check()
end

function load_hand()
 for a = 1,players do
  for c = 1,7 do
     pick_card(a)
  end
 player[a].selected = 4
 end
end

function starting_card()
		a = math.random(104)
  while cards[a].hand ~= 0 do
  		a = math.random(104)
  end
  cards[a].hand = 5
  discard = a
  cards_left = cards_left - 1
  cur_player = dealer + 1
  if cur_player > players then cur_player = 1; end
  draw_background()
  verdana24:activate()
  verdana24:print(185, 35 , yellow, "Round " .. round)
 	verdana24:print(110, 95 , yellow, "The dealer is Player " .. dealer )
 	verdana24:print(118, 150 , yellow, "Player " .. cur_player .. " will go first" )
 	verdana24:print(160, 215 , yellow, "Press any key" )
		end_draw()
  shuf1:play()
		cont()
		first_play()
end

function first_play()
  quick()
  verdana12:activate()
		verdana12:print(195, 80 , yellow, "Press any key")
		end_draw()
		cont()

  if cards[discard].value == 98 then
         wild = 1
									if cur_player == 1 then
									   wild_pick(); quick(); end_draw()
		       else
						      examine(cur_player)
            suitc = 1
						      for a = 2,4 do
						         if player[cur_player].clr_ct[a] > player[cur_player].clr_ct[suitc] then suitc = a; end
												end
									   wild_suit = suitc
									   if wild_suit == 1 then stclr = "Red." end
									   if wild_suit == 2 then stclr = "Green." end
									   if wild_suit == 3 then stclr = "Blue." end
									   if wild_suit == 4 then stclr = "Yellow." end
									   quick();  verdana12:activate()
          		verdana12:print(195, 80 , yellow, "I choose " .. stclr)
          		end_draw() ; 	pge.delay(1000000)
									end
  end
		if cards[discard].value == 10 then
		 		if players == 2 then cur_player = dealer; end
					check_special(cur_player, discard); upd_player()
		end
		if cards[discard].value == 11 then cur_player = dealer; check_special(cur_player, discard); upd_player();end
		if cards[discard].value == 12 then cur_player = dealer; check_special(cur_player, discard); upd_player();end

end

function draw_background()
 pge.gfx.startdrawing() ;  pge.gfx.clearscreen()
 felt:activate() ; felt:draweasy(0,0)
end

function draw_discard()
  x = cards[ discard ].picx ;   y = cards[ discard ].picy
  if wild == 1 then
     if wild_suit == 1 then x=2; y=4; end
     if wild_suit == 2 then x=3 y=4; end
     if wild_suit == 3 then x=4 y=4; end
     if wild_suit == 4 then x=5; y=4; end
		end
  thecards:activate()
  thecards:draw(243, 100, 39, 62, (x*39) , y * 62, 39, 62, 0)
  thecards:draw(188, 100, 39, 62, (6*39) , 4 * 62, 39, 62, 0)
end

function draw_hand(b)
	examine(b)
 ln = 0  ; yoff = 200
	if player[b].selected == 1 then xoff =  220; min = 1; max = 4; end
	if player[b].selected == 2 then xoff =  175; min = 1; max = 5; end
	if player[b].selected == 3 then xoff =  130; min = 1; max = 6; end
	if player[b].selected > 3 then xoff =  85; min = player[b].selected - 3; max = min + 6; end
	if max > player[b].count then max = player[b].count ; end
 for a = min, max do
 		cd =  player[b].player_cards[a]
	 	if player[b].playable[a] == 1 then op = 255 else op = 100; end
   x = cards[cd].picx ;   y = cards[cd].picy
   thecards:activate()
   if player[b].selected == a then
      thecards:draw((ln*45) + xoff, (b * yoff) -10, 39, 62, (x*39) , y * 62, 39, 62, 0, op)
 		else
      thecards:draw((ln*45) + xoff, (b * yoff) , 39, 62, (x*39) , y * 62, 39, 62, 0, op)
   end
   ln = ln + 1
 end
end

function  end_draw()
 pge.gfx.enddrawing(); pge.gfx.swapbuffers()
end

function shuffle_check()
  if cards_left < 6 then
    for a = 1, 108 do
      if cards[a].hand == 5 then cards[a].hand = 0; cards_left = cards_left + 1; end
			 end
			 cards[discard].hand = 5; cards_left = cards_left - 1
			 play_shuf()
		end
end

function play_shuf()
			 shuf1:play()
			 x1={0,210,460,0,210,460} ; y1 = {0,0,0,210,210,210}
			 step = 20 ; xt = 180 ; yt = 100
			 for m = 1, step do
						quick()
  	 		for a = 1, 6 do
     	  thecards:activate() ;
   	    thecards:draw(x1[a], y1[a], 39, 62, (6*39) , 4 * 62, 39, 62, 0)
 			 	end
      end_draw()
 		   x1[1] = x1[1] + (xt/step); x1[3] = x1[3] - (xt/step) ; x1[4] = x1[4] + (xt/step); x1[6] = x1[6] - (xt/step)
			   y1[1] = y1[1] + (yt/step); y1[2] = y1[2] + (yt/step);  y1[3] = y1[3] + (yt/step)
			   y1[4] = y1[4] - (yt/step); y1[5] = y1[5] - (yt/step) ; y1[6] = y1[6] - (yt/step)
			 end
end

function center_card(a)
			quick()
   thecards:activate()
   if a == 0 then
   	  x = 6 ;   y = 4
      thecards:draw(200, 50 , 78, 124, (x*39) , y * 62, 39, 62, 0, 255)
      verdana12:activate()
    		verdana12:print(193, 80 , yellow, "Drawing a card")
			else
   	  x = cards[a].picx ;   y = cards[a].picy
      thecards:draw(200, 50 , 78, 124, (x*39) , y * 62, 39, 62, 0, 255)
   end
   end_draw()
   pge.delay(350000)
   quick()
   end_draw()
end

function wild_pick()
last_sel = player[1].selected
lp = 0
   while  lp == 0 do
     draw_background()
     draw_hand(1)
   		verdana24:activate()
     verdana24:print(130, 65 , yellow, "Choose the suit")
   		thecards:activate()
   		thecards:draw(160, 100, 39, 62, (2*39) ,  4*62, 39, 62, 0)
   		thecards:draw(200, 100, 39, 62, (3*39) ,  4*62, 39, 62, 0)
   		thecards:draw(240, 100, 39, 62, (4*39) ,  4*62, 39, 62, 0)
   		thecards:draw(280, 100, 39, 62, (5*39) ,  4*62, 39, 62, 0)
   		thecards:draw(160, 100, 39, 62, (7*39) , 4*62, 39, 62, 0)
   		thecards:draw(200, 100, 39, 62, (8*39) , 4*62, 39, 62, 0)
   		thecards:draw(240, 100, 39, 62, (9*39) , 4*62, 39, 62, 0)
   		thecards:draw(280, 100, 39, 62, (10*39) , 4*62, 39, 62, 0)
     end_draw()

     cont()
  			if ctrl == 7 then wild_suit = 1; lp = 1 ; end
  			if ctrl == 8 then wild_suit = 2; lp = 1 ; end
  			if ctrl == 9 then wild_suit = 3; lp = 1 ; end
  			if ctrl == 10 then wild_suit = 4; lp = 1 ; end
  		 if ctrl == 3 then
	      player[1].selected = player[1].selected -1;
     end
     if ctrl == 4 then
	      player[1].selected = player[1].selected +1;
    	end
   		if player[1].selected > player[1].count then player[1].selected = 1; end
	    if player[1].selected < 1 then player[1].selected = player[1].count; end
			end
player[1].selected = last_sel
end

function draw_ops()
  if players == 2 then draw_pos2(2);  end
  if players == 3 then draw_pos1(2); draw_pos2(3); end
  if players == 4 then draw_pos1(2); draw_pos2(3); draw_pos3(4); end
end

function draw_pos1(b)
     max = player[b].count;
     if max > 7 then max = 7; end
     stp2 = (200 - (max * 15))/2
					if player[b].count > 7 then
	       verdana12:activate()
     		 verdana12:print( 28, stp2-14 , yellow, "+")
     end
     for p = 1, max  do
       thecards:activate()
       thecards:draw(15, stp2 + ((p-1) * 15), 39, 62, (6*39) , 4 * 62, 39, 62, 0)
					end
end

function draw_pos2(b)
     max = player[b].count;
     if max > 7 then max = 7; end
     stp2 = (480 - (max * 30))/2
					if player[b].count > 7 then
	       verdana12:activate()
     		 verdana12:print(stp2 - 13, 34 , yellow, "+")
     end
     for p = 1, max  do
       thecards:activate()
       thecards:draw(stp2 + ((p-1) * 30), 10, 39, 62, (6*39) , 4 * 62, 39, 62, 0)
					end
end

function draw_pos3(b)
     max = player[b].count;
     if max > 7 then max = 7; end
     stp2 = (200 - (max * 15))/2
					if player[b].count > 7 then
	       verdana12:activate()
     		 verdana12:print( 438, stp2-14 , yellow, "+")
     end
     for p = 1, max  do
       thecards:activate()
       thecards:draw(426, stp2 + ((p-1) * 15), 39, 62, (6*39) , 4 * 62, 39, 62, 0)
					end
end

function defaults()
			lp2 = 0
		 while lp2 == 0 do

   draw_background()
			verdana24:activate()
   verdana24:print(120, 10 , yellow, "Current settings:")
   verdana24:print(50, 50 , yellow, "# of Players: ");  verdana24:print(250, 50 , yellow, players)
   verdana24:print(50, 80 , yellow, "Win with: ")
			if game_type == 1 then verdana24:print(250,80, yellow, "Lowest total") end
			if game_type == 2 then verdana24:print(250,80 , yellow, "Highest total") end
   verdana24:print(50, 110 , yellow, "Play to: ");  verdana24:print(250,110 , yellow, win_sc)
   verdana24:print(50, 140 , yellow, "Draw: ")
			if draw_type == 1 then verdana24:print(250,140, yellow, "Until you can play") end
			if draw_type == 2 then verdana24:print(250,140 , yellow, "Only once"); end
   verdana24:print(50, 170 , yellow, "Play Wild +4: ")
			if wild_type == 1 then verdana24:print(250,170, yellow, "Anytime"); end
			if wild_type == 2 then verdana24:print(250,170, yellow, "No color match"); end
			if wild_type == 3 then verdana24:print(250,170, yellow, "Nothing else"); end
   verdana24:print(50, 220 , yellow, "Select option or START to play")
   thecards:activate()
			thecards:draw(10, 30, 39, 62, (11*39) , 4*62, 39, 62, 0)
			thecards:draw(10, 60, 39, 62, (7*39) , 4*62, 39, 62, 0)
			thecards:draw(10, 90, 39, 62, (8*39) , 4*62, 39, 62, 0)
			thecards:draw(10, 120, 39, 62, (9*39) , 4*62, 39, 62, 0)
			thecards:draw(10, 150, 39, 62, (10*39) , 4*62, 39, 62, 0)

			end_draw()

 	   pge.controls.update()
   	 if pge.controls.pressed(PGE_CTRL_START) then lp2 = 1 ; end
   	 if pge.controls.pressed(PGE_CTRL_SELECT) then pic_players(); end
   	 if pge.controls.pressed(PGE_CTRL_SQUARE) then set_game_type(); end
   	 if pge.controls.pressed(PGE_CTRL_TRIANGLE) then set_score(); end
   	 if pge.controls.pressed(PGE_CTRL_CIRCLE) then set_draw_type(); end
   	 if pge.controls.pressed(PGE_CTRL_CROSS) then set_wild_type(); end
			end
end

function pic_players()
   draw_background()
			verdana24:activate()
   verdana24:print(130, 45 , yellow, "How many players?")
			thecards:activate()
			thecards:draw(100, 100, 39, 62, (2*39) ,  62, 39, 62, 0)
			thecards:draw(221, 100, 39, 62, (3*39) ,  62, 39, 62, 0)
			thecards:draw(341, 100, 39, 62, (4*39) ,  62, 39, 62, 0)
			thecards:draw(100, 170, 39, 62, (7*39) , 4*62, 39, 62, 0)
			thecards:draw(221, 170, 39, 62, (8*39) , 4*62, 39, 62, 0)
			thecards:draw(341, 170, 39, 62, (9*39) , 4*62, 39, 62, 0)
			end_draw()
			lp = 0
   while lp== 0 do
      cont()
      if ctrl == 7 then players = 2; lp = 1 ; end
      if ctrl == 8 then players = 3; lp = 1 ; end
      if ctrl == 9 then players = 4; lp = 1 ; end
			end
end

function set_game_type()
   draw_background()
			verdana24:activate()
   verdana24:print(45, 20 , yellow, "The winning condtions:")
   verdana12:activate()
   verdana12:print(50, 60 , yellow, "When a player plays their last card, each player collects")
   verdana12:print(50, 80, yellow, "points for the cards in their hand.")
   verdana12:print(50, 100 , yellow, "When a player reaches the chosen score, the player with the")
   verdana12:print(50, 120 , yellow, "the lowest point total wins.")
   verdana12:print(50, 160 , yellow, "The player to play the last card collects points")
   verdana12:print(50, 180, yellow, "for each card left in the other players hand.")
   verdana12:print(50, 200 , yellow, "The game is won when the player reaches the chosen score.")
 		thecards:activate()
			thecards:draw(10, 50, 39, 62, (7*39) , 4*62, 39, 62, 0)
			thecards:draw(10, 150, 39, 62, (8*39) , 4*62, 39, 62, 0)
			end_draw()
			lp = 0
   while lp== 0 do
      cont()
      if ctrl == 7 then game_type = 1; lp = 1 ; end
      if ctrl == 8 then game_type = 2; lp = 1 ; end
			end
end

function set_score()
   draw_background()
			verdana24:activate()
   verdana24:print(90, 45 , yellow, "Game ends at what score?")
   verdana24:print(115, 115 , yellow, "250    500    750    1000")
			thecards:activate()
			thecards:draw(122, 150, 39, 62, (7*39) , 4*62, 39, 62, 0)
			thecards:draw(190, 150, 39, 62, (8*39) , 4*62, 39, 62, 0)
			thecards:draw(260, 150, 39, 62, (9*39) , 4*62, 39, 62, 0)
			thecards:draw(334, 150, 39, 62, (10*39) , 4*62, 39, 62, 0)
			end_draw()
			lp = 0
   while lp== 0 do
      cont()
      if ctrl == 7 then win_sc = 250; lp = 1 ; end
      if ctrl == 8 then win_sc = 500; lp = 1 ; end
      if ctrl == 9 then win_sc = 750; lp = 1 ; end
      if ctrl == 10 then win_sc = 1000; lp = 1 ; end
			end
end

function set_draw_type()
   draw_background()
			verdana24:activate()
   verdana24:print(30, 25 , yellow, "When you cannot play a card you:")
   verdana24:print(60, 95 , yellow, "Draw until you can play.")
   verdana24:print(60, 145 , yellow, "Draw one card and play passes.")
			thecards:activate()
			thecards:draw(20, 77, 39, 62, (7*39) , 4*62, 39, 62, 0)
			thecards:draw(20, 127, 39, 62, (8*39) , 4*62, 39, 62, 0)
			end_draw()
			lp = 0
   while lp== 0 do
      cont()
      if ctrl == 7 then draw_type = 1; lp = 1 ; end
      if ctrl == 8 then draw_type = 2; lp = 1 ; end
			end
end

function set_wild_type()
   draw_background()
			verdana24:activate()
   verdana24:print(30, 25 , yellow, "You can play a WILD +4 Card:")
   verdana24:print(60, 95 , yellow, "Anytime.")
   verdana24:print(60, 145 , yellow, "When you don't have the color.")
   verdana24:print(60, 195 , yellow, "Only when you can't play anything")
   verdana24:print(60, 220 , yellow, "else.")
			thecards:activate()
			thecards:draw(20, 77, 39, 62, (7*39) , 4*62, 39, 62, 0)
			thecards:draw(20, 127, 39, 62, (8*39) , 4*62, 39, 62, 0)
			thecards:draw(20, 177, 39, 62, (9*39) , 4*62, 39, 62, 0)
			end_draw()
			lp = 0
   while lp== 0 do
      cont()
      if ctrl == 7 then wild_type = 1; lp = 1 ; end
      if ctrl == 8 then wild_type = 2; lp = 1 ; end
      if ctrl == 9 then wild_type = 3; lp = 1 ; end
			end
end

function played_card(b)
   player[b].count = player[b].count - 1
   card_play:play()
 		table.remove(player[b].player_cards,player[b].selected)
   table.sort(player[b].player_cards)
			if player[b].count == 1 then
      last[b] = 1 ; last_called[b] = 0
   else
						last[b] = 0; last_called[b] = 0
   end
			if player[b].count == 0 then
      newrd = b
   end
end

function upd_player()

  cur_player = cur_player + clockwise
  if cur_player < 1 then cur_player = players; end
  if cur_player > players then cur_player = 1; end

		quick()
  if cur_player ~= 1 then
     verdana12:activate()
   		verdana12:print(195, 80 , yellow, "Press any key")
  end
  end_draw()

  if cur_player ~= 1 then
 				-- pge.delay(500000) this will auto play
					cont()
		end
end

function mark_player()
		if players == 2 then
		   if cur_player == 1 then arrow = 4; end
					if cur_player == 2 then arrow = 2; end
		end
		if players == 3 then
					if cur_player == 1 then arrow = 4; end
					if cur_player == 2 then arrow = 1; end
					if cur_player == 3 then arrow = 2; end
		end
		if players == 4 then
					if cur_player == 1 then arrow = 4; end
					if cur_player == 2 then arrow = 1; end
					if cur_player == 3 then arrow = 2; end
					if cur_player == 4 then arrow = 3; end
		end
  hand_ptr:activate()
		if arrow == 1 then 	hand_ptr:draweasy(-15, 95, 1.57) ; end
		if arrow == 2 then 	hand_ptr:draweasy(219, -15, 3.14) ; end
		if arrow == 3 then 	hand_ptr:draweasy(440, 95, 4.71) ; end
		if arrow == 4 then  hand_ptr:draweasy(205,230) ; end
		if clockwise == 1 then
    		clk:activate()
		    clk:draweasy (10,210)
		else
    		cclk:activate()
		    cclk:draweasy (10,210)
		end
end

function check_special(b,cd)
   val = cards[cd].value
   if val > 9 then
      if val == 10 then
			      clockwise = clockwise * -1
			      if players == 2 then cur_player = cur_player + 1 end
   						if cur_player < 1 then cur_player = players end
			   			if cur_player > players then cur_player = 1 end
			      rev:play()
   			end
      if val == 11 then
						   cur_player = cur_player + clockwise
   						if cur_player < 1 then cur_player = players end
			   			if cur_player > players then cur_player = 1 end
						   sk[cur_player]:play()
   			end
      if val == 12 then
						   cur_player = cur_player + clockwise
   						if cur_player < 1 then cur_player = players end
			   			if cur_player > players then cur_player = 1 end
						   d2[cur_player]:play()
         for a = 1, 2 do
            pick_card(cur_player)
            center_card(0)
         end
			   end
      if val == 99 then
			   			cur_player = cur_player + clockwise
						   if cur_player < 1 then cur_player = players end
   						if cur_player > players then cur_player = 1 end
			   			d4[cur_player]:play()
         for a = 1, 4 do
            pick_card(cur_player)
            center_card(0)
         end
   			end
   end
end


function examine(a)
   player[a].valid = 0;  smatch = 0; nmatch =0
   for c = 1, 5 do
	     player[a].clr_ct[c] = 0; 	player[a].clr_pt[c] = 0
   end
   for b = 1, player[a].count do
      player[a].playable[b] = 0
      cd = player[a].player_cards[b]
		    player[a].clr_ct[cards[cd].suit] = player[a].clr_ct[cards[cd].suit] + 1
      cdp = 0 ; cdp = cards[cd].value
    		if cards[cd].value > 9 then cdp = 20; end
    		if cards[cd].value > 97 then cdp = 50; end
		    player[a].clr_pt[cards[cd].suit] = player[a].clr_pt[cards[cd].suit] + cdp
     	if wild == 0 then
       		if cards[cd].suit == cards[discard].suit then player[a].playable[b] = 1; player[a].valid = 1; smatch = 1; end
  		     if cards[cd].value == cards[discard].value then player[a].playable[b] = 1; player[a].valid = 1; nmatch = 1; end
      end
	    	if wild == 1 then
  	     	if cards[cd].suit == wild_suit then player[a].playable[b] = 1; player[a].valid = 1; smatch = 1; end
      end
      if cd > 100 then
         if cd < 105 then player[a].playable[b] = 1; player[a].valid = 1; end
      end
    		if cd > 104 then
		       if wild_type == 1 then player[a].playable[b] = 1; player[a].valid = 1; end
		       if wild_type == 2 then
		          if smatch == 0 then player[a].playable[b] = 1; player[a].valid = 1; end
		       end
		       if wild_type == 3 then
		          if smatch + nmatch == 0 then player[a].playable[b] = 1; player[a].valid = 1; end
		       end
   	 	end
   end
end

function ai(b)
			pl = b
			lc_check()
   examine(pl)
   if player[pl].valid == 1 then
      play_me = 0

      while play_me == 0 do
         rnd = math.random(player[pl].count)
						   play_me = player[pl].playable[rnd]
						end
						play_me = rnd

						lowest = 109
						for q = 1,players do
						   if q ~= pl then
						      if player[q].count < lowest then lowest = player[q].count; end
									end
						end

			   best_suit = 0; tsuit = 0 ; aicd = 0
						for q = 1, player[pl].count do
						   if player[pl].playable[q] == 1 then
						      aicd = player[pl].player_cards[q]
						      tsuit = cards[aicd].suit
						      if player[pl].clr_ct[tsuit] >= best_suit then
												   best_suit = player[pl].clr_ct[tsuit]
												   play_me = q
												end
						   end
						end

      if lowest < 5 then
						   best_suit = 0; tsuit =0; aicd = 0
   						for q = 1, player[pl].count do
   						   if player[pl].playable[q] == 1 then
   						      aicd = player[pl].player_cards[q]
			   			      tsuit = cards[aicd].suit
   						      if player[pl].clr_pt[tsuit] >= best_suit then
															   best_suit = player[pl].clr_pt[tsuit]
															   play_me = q
															end
   						   end
									end
						end

						if lowest < 3 then
						   high_value = 0; tvalue = 0; aicd = 0
   						for q = 1, player[pl].count do
   						   if player[pl].playable[q] == 1 then
   						      aicd = player[pl].player_cards[q]
   						      tvalue = cards[aicd].value
   						      if tvalue >= high_value then
															   high_value = tvalue
															   play_me = q
															end
   						   end
									end
						end

						player[pl].selected = play_me
   			crd = player[pl].player_cards[play_me]
 		   if crd > 100 then
			      suitc = 1
			      for aa = 2,4 do
			         if player[pl].clr_ct[aa] > player[pl].clr_ct[suitc] then suitc = aa ; end
									end
						   wild = 1; wild_suit = suitc;
						else
						   wild = 0;
						end
  		  cards[crd].hand = 5
  		  discard = crd
						center_card(crd)
  		  check_special(pl,crd)
  		  played_card(pl)
      if player[pl].count == 1 then lc_set(pl); end
      if newrd == 0 then upd_player(); end
			else
			   if aic == 1 then
			      aic = 0 ; upd_player()
			   else
    			  pick_card(pl)
      			center_card(0)
         if draw_type == 2 then aic = 1 end
         ai(pl)
      end
			end
end

function player1()
	cont()
	quick(); end_draw()
 if ctrl == 3 then
	   player[1].selected = player[1].selected -1;
   	if player[1].selected < 1 then player[1].selected = player[1].count; end
 end
 if ctrl == 4 then
	   player[1].selected = player[1].selected +1;
   	if player[1].selected > player[1].count then player[1].selected = 1; end
	end
 if ctrl == 10 then
			examine(1)
			if player[1].playable[player[1].selected] == 1 then
   			crd = player[1].player_cards[player[1].selected]
 		   if crd > 100 then wild = 1; wild_suit = 0; else wild = 0; end
  		  cards[crd].hand = 5
  		  discard = crd
						center_card(crd)
						if player[1].count > 1 then
         if wild == 1 then wild_pick(); ctrl = 0; end -- played wild card last no need for suit (FIX?)
  	   end
				  check_special(1,crd)
  		  played_card(1)
						quick() ; end_draw()
						if newrd == 0 then
         upd_player()
      end
     	if player[1].selected > player[1].count then player[1].selected = player[1].count; end
			else
      no:play()
			end
	end
	if ctrl == 9 then
	   examine(1)
	   if player[1].valid == 0 then
				   pick_card(1); center_card(last_draw)
				   if draw_type == 2 then
   				   examine(1)
			   	   if player[1].valid == 0 then
			   	      upd_player()
										end
							end
				else
       no:play()
				end
	end
end

function lc_set(b)
   if last[b] == 1 then
      if last_called[b] == 0 then
         last_called[b] = 1;  lastcard:play()
      end
   end
end

function lc_check()
  if last[1] == 1 then
     if last_called[1] == 0 then
					   d2[1]:play()
        for a = 1, 2 do
           pick_card(1)
           center_card(last_draw)
        end
								quick()
					   verdana24:activate()
        verdana24:print(83,73, yellow, "You didn't call Last Card!")
        end_draw()
        cont()
     end
		end
end

function check_win()
			win = 0
			for a = 1,players do
			   if player[a].score > win_sc then win = 1 end
			end
			if win == 1 then
			   if game_type == 1 then
   						winner = 1
			      for a = 2, players do
			         if player[a].score < player[winner].score then
			            winner = a
			         end
						   end
						end

						if game_type == 2 then
   						winner = 1
			      for a = 2, players do
			         if player[a].score > player[winner].score then
			            winner = a
   			      end
			   			end
						end

						draw_background()
			   verdana24:activate()
      verdana24:print(83,23, yellow, "Player " .. winner .. " has won the game!!")
      verdana24:print(83,53, yellow, "Final scores:")
						for a = 1,players do
         verdana24:print(83,83+(a*30), yellow, "Player " .. a .. " Score: " .. player[a].score)
      end
						end_draw()
      cont()
      won = 1
			end
end

function replay()
			wild = 0 ; wild_suit = 0 ; clockwise = 1 ; last_draw = 0; round = 1
   for a = 1, 4 do
      player[a].count=0;  player[a].selected=4 ; player[a].valid=0; player[a].score=0
      last[a] = 0 ; last_called[a] = 0
			end
			for a = 1, 108 do
			   cards[a].hand = 0
			end
			cards_left = 108; 			newrd = 0
			defaults()
			--pic_players()
   dealer = math.random(players)
			load_hand()
			starting_card()
			quick()
   end_draw()
end

function cont()
  ctrl = 0
	 while ctrl == 0 do
 	   pge.controls.update()
   	 if pge.controls.pressed(PGE_CTRL_START) then ctrl = 1 ; end
   	 if pge.controls.pressed(PGE_CTRL_SELECT) then ctrl = 2 ; end
   	 if pge.controls.pressed(PGE_CTRL_LEFT) then ctrl = 3 ; end
   	 if pge.controls.pressed(PGE_CTRL_RIGHT) then ctrl = 4 ; end
   	 if pge.controls.pressed(PGE_CTRL_UP) then ctrl = 5 ; end
   	 if pge.controls.pressed(PGE_CTRL_DOWN) then ctrl = 6 ; end
   	 if pge.controls.pressed(PGE_CTRL_SQUARE) then ctrl = 7 ; end
   	 if pge.controls.pressed(PGE_CTRL_TRIANGLE) then ctrl = 8 ; end
   	 if pge.controls.pressed(PGE_CTRL_CIRCLE) then ctrl = 9 ; end
   	 if pge.controls.pressed(PGE_CTRL_CROSS) then ctrl = 10 ; end
   	 if pge.controls.pressed(PGE_CTRL_LTRIGGER) then ctrl = 11 ; end
   	 if pge.controls.pressed(PGE_CTRL_RTRIGGER) then ctrl = 12 ; end
   	 if pge.controls.held(PGE_CTRL_TRIANGLE + PGE_CTRL_UP) then ctrl = 0; replay(); end
   	 if pge.controls.held(PGE_CTRL_TRIANGLE + PGE_CTRL_DOWN) then ctrl = 0; pge.exit(); end
  end
  if ctrl == 12 then ctrl =0; lc_set(1); end
end

function ready()
 init_tables()
 clear_cards()
 defaults()
 dealer = math.random(players)
 load_hand()
	starting_card()
	quick()
 end_draw()
end

function quick()
 draw_background()
 draw_discard()
 draw_ops()
 draw_hand(1)
 mark_player()
 verdana24:activate()
	verdana24:print(5, 0 , yellow, "Player " .. cur_player )
 verdana24:print(375, 0 , yellow, "Round " .. round)
 verdana12:activate()
 verdana12:print(415, 203 , yellow, "Scores")
    for a = 1,players do
       verdana12:print(415, 208 + a * 12, yellow, "P"..a.." - ")
		 				verdana12:print(445, 208 + a * 12, yellow, player[a].score)
    end
end

-- Start game
contest()
intro1()
intro2()
ready()

while pge.running() do
  quick(); end_draw()
 	if newrd == 0 then
   	 if cur_player == 1 then
 	      player1()
 	   else
 	      aic = 0
 	      ai(cur_player)
     end
 	else
     new_round()
     if won == 1 then won = 0; replay();end
  end
end